質問編集履歴

2

エラーがでました。

2022/10/04 08:27

投稿

ke0313
ke0313

score63

test CHANGED
File without changes
test CHANGED
@@ -3,8 +3,8 @@
3
3
 
4
4
  github(https://github.com/hobby-overflow/LF_HF_Monitor/blob/master/LF_HF_Monitor.py)
5
5
  を実行したいです。
6
- データとして、写真のようなCSVァイルがあります。
6
+ データとして、写真のようなデータレームがあります。
7
- ![イメージ説明](https://ddjkaamml8q8x.cloudfront.net/questions/2022-10-03/625e5145-24d4-4fb3-94fa-378f41eddf27.png)
7
+ ![イメージ説明](https://ddjkaamml8q8x.cloudfront.net/questions/2022-10-04/09a111ff-b388-49b6-96e1-467d558bbcba.png)
8
8
  このデータを使い下記のコードを実行したいのですが、上手くいかないです。
9
9
  変更するべき点を教えて頂きたいです。
10
10
 
@@ -112,19 +112,24 @@
112
112
 
113
113
  ### 試したこと
114
114
  ```
115
+ import pandas as pd
116
+ import numpy as np
117
+ import datetime as dt
118
+ from scipy.signal import lombscargle, welch
119
+ from scipy.interpolate import splrep, splev
120
+ import pandas.tseries.offsets as offsets
121
+ from dateutil import parser
122
+ from pytz import timezone
123
+
115
124
  # csv読み込み
116
- df = pd.read_csv(r"C: csvデータ\HeartRate_0622 (1).csv")
125
+ #df = pd.read_csv("C:\Users\ csvデータ\HeartRate_0622 (1).csv")
117
- df = df.drop(0)
126
+ #df = df.drop(0)
118
127
  # カラムの名前を変更
119
- df = df.rename(columns={"DateTime": "date","TimeDelta":"elapsed_time","HeartRate": "hr"})
128
+ df = df.rename(columns={"Datetime": "date", "HeartRate": "hr"})
120
- #df["date"]=df['date'].astype(str)
121
- #df["test"] = [(dt.datetime.strptime(df["date"][i + 1], "%Y-%m-%d %H:%M:%S")) for i in range(0, len(df))]
129
+ df["test"] = [(dt.datetime.strptime(df["date"][i + 1], "%Y-%m-%d %H:%M:%S")) for i in range(0, len(df))]
122
- #df['test'] = pd.to_datetime(df['date'])
123
- df["test"]=df["date"]
124
- #start_time = df.iloc[0, 0]
130
+ start_time = df.iloc[0, 0]
125
- #st = int(parser.parse(start_time).timestamp())
131
+ st = int(parser.parse(start_time).timestamp())
126
- #df["elapsed_time"] = [int(parser.parse(i).timestamp()) - st for i in df["date"]]
132
+ df["elapsed_time"] = [int(parser.parse(i).timestamp()) - st for i in df["date"]]
127
-
128
133
  df["rri"] = [(60 * 1000 / int(i)) for i in df["hr"]]
129
134
  df.set_index("date", inplace=True)
130
135
 
@@ -142,7 +147,6 @@
142
147
 
143
148
  start = dt.datetime(year, mouth, day, h, st)
144
149
  end = dt.datetime(year, mouth, day, h, en)
145
-
146
150
  return df[(df["test"] > start) & (df["test"] < end)]
147
151
 
148
152
  print("Test")
@@ -153,7 +157,7 @@
153
157
  # 範囲指定で取り出す
154
158
  # print(df[(df["test"] > dt.datetime(2019,6,13,0,1)) & (df["test"] < dt.datetime(2019,6,13,0,2))])
155
159
 
156
- time_data = df["test"][5727:]
160
+ time_data = df["test"][4758:]
157
161
  cnt = 0
158
162
  # print(df[(df["test"] > dt.datetime(2019,6,13,14) - offsets.Minute(1))])
159
163
  print("Start")
@@ -204,5 +208,22 @@
204
208
  #print(df["lf_hf"])
205
209
 
206
210
  # 時 分 秒
207
-
211
+ ```
212
+
208
-
213
+ ```
214
+ #エラー
215
+ The above exception was the direct cause of the following exception:
216
+
217
+ KeyError Traceback (most recent call last)
218
+ ~\AppData\Local\Temp/ipykernel_20436/2118628457.py in <module>
219
+ 13 # カラムの名前を変更
220
+ 14 df = df.rename(columns={"Datetime": "date", "HeartRate": "hr"})
221
+ ---> 15 df["test"] = [(dt.datetime.strptime(df["date"][i + 1], "%Y-%m-%d %H:%M:%S")) for i in range(0, len(df))]
222
+ 16 start_time = df.iloc[0, 0]
223
+ ...
224
+ -> 3363 raise KeyError(key) from err
225
+ 3364
226
+ 3365 if is_scalar(key) and isna(key) and not self.hasnans:
227
+
228
+ KeyError: 'date'
229
+

1

書式

2022/10/03 04:32

投稿

ke0313
ke0313

score63

test CHANGED
File without changes
test CHANGED
@@ -144,7 +144,7 @@
144
144
  end = dt.datetime(year, mouth, day, h, en)
145
145
 
146
146
  return df[(df["test"] > start) & (df["test"] < end)]
147
- """
147
+
148
148
  print("Test")
149
149
 
150
150
  # 一分間隔でグループにする
@@ -204,5 +204,5 @@
204
204
  #print(df["lf_hf"])
205
205
 
206
206
  # 時 分 秒
207
- """
207
+
208
-
208
+